#!/bin/bash

# Altough this script is similar to the SCRIPT-config.sh scripts, it differs
# much. Lib config scripts should export global vars, write the logs
# and the standard output.

# The bottleneck is the recursive mutex initializer, this script will try
# to use that to prove pthreads work.

function try_pthread {
	q=`echo '
#define _GNU_SOURCE 1 // Needed for recursive thread-locking
#include <'$1'pthread.h>
pthread_mutex_t mutex = PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP;
int main() {	
	printf("OK");
	return 0;
}
	'  | test_compile`

	echo "[libs] Trying pthread with $1, $LDFLAGS -> $q" >> $LOG

	if test "$q" = "OK"
	then
		export lpthread="$LDFLAGS"
		export with_sys_ldflags="$with_sys_ldflags $lpthread"
		db_add sys_ldflags "$with_sys_ldfags" DB_osdep
		return 0
	fi

	return 1
}

function pthread_find() {
	LDFLAGS="-lpthread"
	try_pthread "" 2>/dev/null && return
	LDFLAGS="-lpthreadGC2"
	try_pthread "" 2>/dev/null && return

	echo "FAILED."
	echo "
Your system does not have pthread, or it does not support recursive mutex
initializers or the script just can't find it. Threads are disabled."
	with_option_threads=0
	echo "[pthreads-config] disabled threads option" >> $LOG
	#rerun the compiler detection to change the thread settings
	LDFLAGS=""
	compiler_detect
}

echo -n "Libs: detecting pthread... "
pthread_find
echo "ok"
