/*
    libgpmi - General Package/Module Interface - EMPTY module
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * Replace:
 *  .empty  -> .extension
 *  Empty -> Module
 *  empty -> module
 */

#include "empty.h"

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "gpmi/debug.h"

/**
 * Returns the extension of this script-module.
 */
char *Empty_GetExtension()
{
	return strdup(".empty");
}

/**
 * Reloads the script on the fly.
 */
int Empty_Rehash(void *client_data)
{
	/* TODO */
	return 0;
}

/**
 * Loads a script.
 */
int Empty_LoadScript(void *client_data, const char *filename)
{
	Empty_ClientData *Empty_MyData = client_data;

	return 0;
}

/**
 * Execute a dynamic command.
 **/
static int Empty_DynamicPackageCommand(/* Params are language depending */)
{
	Empty_ClientData *Empty_MyData = GPMI_Script_GetClientData();
	char *(*proc)(int argc, char *argv[]);
	char *s;

	proc = GPMI_Script_FindProc(function_name);

	/* Check if command not found - this must be an internal error: the
	   package had registered the command in the hash, but the routine
	   pointer is NULL.
	*/
	if (proc == NULL) {
		gpmi_debug(0, "[Empty] Internal error: %s has a NULL proc in the command hash\n", function_name);
		return 0;
	}

	s = proc(argc + 1, args);

	return 1;
}

/**
 * Register a command in our command hash
 */
void Empty_RegisterCommand(void *client_data, const char *name)
{
	Empty_ClientData *Empty_MyData = client_data;
}

/**
 * Call a function of the script by name, passing params.
 */
void Empty_RunFunction(void *client_data, const char *function, int argc, const char **argv)
{
	Empty_ClientData *Empty_MyData = client_data;
}

int Empty_Initialize(void **client_data)
{
	Empty_ClientData *MyData;

	MyData = malloc(sizeof(Empty_ClientData));
	memset(MyData, 0, sizeof(Empty_ClientData));

	*client_data = MyData;

	return 0;
}

void Empty_Destroy(void **client_data)
{
	Empty_ClientData *Empty_MyData = *client_data;

	/* Finally free up the client-data */
	free(*client_data);
}
