/*
    libgpmi - General Package/Module Interface - php module
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef SCRIPT_MODULE_PHP_H
#define SCRIPT_MODULE_PHP_H

#include "packages/gpmi_scripts.h"

typedef struct PHP_ClientData {
	void *functions;
	int func_count;
} PHP_ClientData;

int  PHP_Initialize(void **client_data);
void PHP_Destroy(void **client_data);
void PHP_RegisterCommand(void *client_data, const char *name);
int  PHP_LoadScript(void *client_data, const char *filename);
char *PHP_GetExtension();
void PHP_CallFunction(void *client_data, const char *function, int argc, const char **argv);

void PHP_Uninitialize( void );

#endif /* SCRIPT_MODULE_PHP_H */
