/*
    libgpmi - General Package/Module Interface - gpmi_scripts package
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef GPMI_SCRIPT_SCRIPTS_H
#define GPMI_SCRIPT_SCRIPTS_H

#include "gpmi/hash/hash.h"
#include "packages/timer.h"
#include "module_events.h"

char *(*gpmi_scripts_asm_scriptname)(const GPMI_Script_Info *info, const char *file_name);


typedef struct GPMI_Script_ClientData {
	const GPMI_Script_Info *info;

	char *current_script_dir;

	hash_t *cmd_hash;
	module_events *events;

	int last_frame;
	timer_list *timers;
	gpmi_package *timer_pkg;

	void *client_data;

	gpmi_package *package;
} GPMI_Script_ClientData;


typedef struct GPMI_Script_EventData {
	GPMI_Script_ClientData *client_data;
	int argc;
	char **argv;
} GPMI_Script_EventData;

typedef struct GPMI_Script_TimerData {
	char *script;
	char *user_data;
	int TTL;
	int freq;
} GPMI_Script_TimerData;

void GPMI_Script_RegisterCommand(void *handle, char *name, void *proc_wrapper, void *proc_lowlevel, gpmi_package *pkg);
void GPMI_Script_Event_Callback(void *handle, void *data);
void GPMI_Script_Timer_Callback(timer_cmds cmd, void *data, timer *timer);
void GPMI_Script_FreeModuleEventData(void *data);
int  GPMI_Script_CompareModuleEventData(void *data1, void *data2);
#endif /* GPMI_SCRIPT_SCRIPTS_H */
