/*
    libgpmi - General Package/Module Interface - hash interace package
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <gpmi.h>

void *gpmi_hash_create(int size);
void gpmi_hash_store(void *table, char *key, char *data);
char *gpmi_hash_find(void *table, const char *key);
int gpmi_hash_stat_recno(void *table);
int gpmi_hash_stat_empty_node(void *table);
double gpmi_hash_stat_avg_node(void *table);
int gpmi_hash_stat_max_node(void *table);
int gpmi_hash_stat_mem(void *table);
void *gpmi_hash_rehash(void *table, int new_size);

void *hash_cursor_new(void *h);
void *hash_cursor_next(void *curs);
void *hash_cursor_key(void *curs);
void *hash_cursor_data(void *curs);
void hash_cursor_data_write(void *curs, void *new_data);
void hash_cursor_destroy(void *curs);
void *hash_cursor_rewind(void *curs);
