# This is an example how to use tcl with gpmi. This script is also part of
# the regression test

proc RunData {data} {
	gpmi_puts "main:RunData $data == 0x1234"
}

proc ev_cycle {timer_data} {
	global TTL_expected
	global freq_expected

	set TTL [TimerInfo $timer_data TTL]
	set freq [TimerInfo $timer_data freq]
	set user_data [TimerInfo $timer_data user_data]

	gpmi_puts "main:ev_cycle ( $TTL == $TTL_expected )  ( $freq == $freq_expected ) ( $user_data == data1 ) (runs 4 times)"
	set TTL_expected [incr TTL_expected -1]
}

proc ev_every_second {timer_data} {
	global TTL_expected
	global freq_expected
	
	set TTL [TimerInfo $timer_data TTL]
	set freq [TimerInfo $timer_data freq]
	set user_data [TimerInfo $timer_data user_data]
	
	gpmi_puts "main:ev_every_second ( $TTL == $TTL_expected )  ( $freq == $freq_expected ) ( $user_data == data2 ) (runs 3 times)"
	set TTL_expected [incr TTL_expected -1]
}

proc ev_nothing {id year param} {
	global year_expected
	global param_expected
	gpmi_puts "main:ev_nothing: year: ( $year == $year_expected ) param: ( $param == $param_expected )"
}

gpmi_puts "main:Running init part."

# Check timers
set TTL_expected 4
set freq_expected 0
AddTimer 4 0 ev_cycle data1

set TTL_expected 3
set freq_expected 2
AddTimer 3 2 ev_every_second data2

# Check package loading
PkgLoad example 0
gpmi_puts "main:main1 [Example_int 10] == 1244 when works"

# Check events
set year_expected 2005
set param_expected 155
Bind Example_nothing ev_nothing
Example_do_nothing 155

# Check FakeEvent
set year_expected 3000
set param_expected 20
FakeEvent Example_nothing "3000 20"

gpmi_puts "main:main2 Finished init part."
