/*
    libgpmi - General Package/Module Interface - wrapgen
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef WRAPGEN_H
#define WRAPGEN_H

#include <time.h>
#include "config.h"
#include "str_buff/str_buff.h"
#include "wrapgen_parser.h"

time_t NOW;

#define cfclose(file)			if ( file != NULL ) \
														fclose(file);

#define cfopen(F, filename, mode)			F = fopen(filename, mode); \
																			fprintf(F,"/*\n * Generated by WrapGen at %s */\n\n", ctime(&NOW));


extern char param[][64];
extern char type[][64];
extern int type_[];
extern int flags[];

extern char *type_declarations[];
extern char *inv_test[];

char *name_space;

/* Split a line in two words */
void split(char *string, char *first, char *second);
int FindType(char *name);
int PrintVarDefs(int *longest_name, int *longest_type, int params, char *cmd, str_buff_t *out_file);

#endif /* WRAPGEN_H */
